// DFPlayer mini(MP3v[[) http://akizukidenshi.com/catalog/g/gM-12544/
// "MPLAB X v4.10" "XC8 v1.40" "PIC16F1829"
#include <xc.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "skUARTlib.h"
#include "skI2Clib.h"
#include "skI2CLCDlib.h"
#include "skDFRPlayerM.h"

#define _XTAL_FREQ 16000000   // gpPICɂ蓮glݒ肷

// RtBM[VP̐ݒ
#pragma config FOSC = INTOSC  // ۯgp(INTOSC)
#pragma config WDTE = OFF     // ޯϰ(OFF)
#pragma config PWRTE = ON     // dON64ms۸тJn(ON)
#pragma config MCLRE = OFF    // OؾĐM͎gp޼ٓ(RA3)݂Ƃ(OFF)
#pragma config CP = OFF       // ۸ذی삵Ȃ(OFF)
#pragma config CPD = OFF      // ްذی삵Ȃ(OFF)
#pragma config BOREN = ON     // dd~펞Ď@\ON(ON)
#pragma config CLKOUTEN = OFF // CLKOUT݂RA4݂Ŏgp(OFF)
#pragma config IESO = OFF     // OEۯ̐ؑւł̋N͂Ȃ(OFF)
#pragma config FCMEN = OFF    // OۯĎȂ(FCMEN_OFF)

// RtBM[VQ̐ݒ
#pragma config WRT = OFF      // Flashذی삵Ȃ(OFF)
#pragma config PLLEN = OFF    // NbN32MHzł͓삳Ȃ(OFF)
#pragma config STVREN = ON    // X^bNI[ot[A_[t[烊Zbg(ON)
#pragma config BORV = LO      // dd~펞Ďd(2.5V)ݒ(LO)
#pragma config LVP = OFF      // dvO~O@\gpȂ(OFF)


// vg^Cv̐錾
void interrupt InterFunction() ;

// ʕϐ̐錾
int lcd_p = 0 ;

/*******************************************************************************
*  荞݂̏                                                              *
*******************************************************************************/
void interrupt InterFunction()
{
     // tr`qs֘A(M)̊荞
     InterUART() ;
     // hQb֘Å荞(LCDŗp)
     InterI2C() ;
}
/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
void main()
{
     // I/O̐ݒ
     OSCCON = 0b01111010 ;    // NbN͂PUlgƂ
     nWPUEN = 0 ;             // vAbvL
     WPUB4  = 1 ;             // RB4(SDA1)vAbv
     WPUB6  = 1 ;             // RB6(SCL1)vAbv
     ANSELA = 0b00000000 ;    // AN0-AN3͎gpȂSăfW^I/OƂ
     ANSELB = 0b00000000 ;    // AN10-AN11͎gpȂSăfW^I/OƂ
     ANSELC = 0b00000000 ;    // AN4-AN9͎gpȂSăfW^I/OƂ
     TRISA  = 0b00000000 ;    // s(RA)͑Sďo͂Ɋ(RA3͓͐p)
     TRISB  = 0b01010000 ;    // RB4(SDA1)RB6(SCL1)͓́Â͑Sďo͂ɊĂ
     TRISC  = 0b00100000 ;    // RC5(RX)̂ݓ́A͑Sďo͂ɊĂ
     PORTA  = 0b00000000 ;    // RA0-RA5o̓s̏(SLOWɂ)
     PORTB  = 0b00000000 ;    // RB4-RB7o̓s̏(SLOWɂ)
     PORTC  = 0b01000000 ;    // RCo̓s̏(SLOWɂ)

     // USARTʐM̏s
     // RX=RC5 TX=RC4 (BaudRate=9600bps Data=8bit Parity=odd Stop=1bit Flow=none)
     InitUART(5,6,103) ;
     // I2CʐM̃}X^[[hŏsAʐMx400KHz
     InitI2C_Master(1) ;
     // I2Cڑ^LCDW[̏
     // ICON OFF,RgXg(0-63),VDD=5.0VŎg,LCD16
     LCD_Init(LCD_NOT_ICON,40,LCD_VDD5V,16) ;
     LCD_Puts("Player  miniTest") ;
     LCD_SetCursor(0,0) ;

     __delay_ms(2000) ;
     // W[̏lݒs(ʂ15x)
     DFRPM_Initiate(15) ;
     DFRPM_SpecifyPlay(1) ;   // gbNԍPĐ
     while(1) {
          // W[瑗ėf[^M鏈
          DFRPM_Receive() ;
     }
}
/*******************************************************************************
*  ReceiveHandler(command,paraH,paraL)                                         *
*  W[̎Mnh[                                          *
*    command : MR}h                                                *
*    paraH   : MMSB̃p[^l                                       *
*    paraH   : MLSB̃p[^l                                       *
*******************************************************************************/
void ReceiveHandler(char command,char paraH,char paraL)
{
     char buf[20] ;
     static int col,row ;

     col = 0 ;
     if (row == 0) row = 1 ;
     else          row = 0 ;
//     PULCDтɂfobO\p(Ԃe\鏈)
//     switch(lcd_p){
//        case 0:
//               row = 0 ; col = 0 ;
//               break ;
//        case 1:
//               row = 0 ; col = 8 ;
//               break ;
//        case 2:
//               row = 1 ; col = 0 ;
//               break ;
//        case 3:
//               row = 1 ; col = 8 ;
//               break ;
//     }
//     lcd_p++ ;
//     if (lcd_p > 3) lcd_p = 0 ;
     LCD_SetCursor(col,row) ;
     switch(command) {
          case 0x3F :
               if (paraL == 0x00) {
                    LCD_Puts("No SD card      ") ;
               }
               break ;
          case 0x3B :
               if (paraL == 0x02) {
                    LCD_Puts("SD card Removed ") ;
               }
               break ;
          case 0x40 :
               sprintf(buf,"error H:%02X L:%02X ",paraH,paraL) ;
               LCD_Puts(buf) ;
               break ;
          default :
               sprintf(buf,"%02X %02X%02X         ",command,paraH,paraL) ;
               LCD_Puts(buf) ;
               break ;
     }
}
