/*******************************************************************************
*  skDFRVoiceM.c - DFROBOTMP3 DFPlayer mini W[p֐Cu       *
*                                                                              *
*    DFRPM_Send            - W[ɃR}h𑗐M鏈                *
*    DFRPM_Receive         - W[R}hM鏈              *
*    DFRPM_Initiate        - W[̏lݒs                  *
*    DFRPM_Reset           - W[̃Zbgs                    *
*    DFRPM_Sleep           - W[X[v鏈                    *
*    DFRPM_Status          - W[݂̌̏Ԃ𓾂鏈                  *
*    DFRPM_PlayNext        - ̋Ȃ̍Đs                            *
*    DFRPM_Pause           - Ȃ̍Đꎞ~鏈                      *
*    DFRPM_Stop            - Ȃ̍Đ~߂鏈                              *
*    DFRPM_Play            - Ȃ̍ĐJn鏈                            *
*    DFRPM_SpecifyPlay     - [gfBNg̋Ȃw肵čĐ鏈      *
*    DFRPM_SpecifyDIR      - tH_̋(255)w肵čĐ鏈       *
*    DFRPM_SpecifyLargeDir - tH_̋(3000)w肵čĐ鏈      *
*    DFRPM_randomPlay      - _ŋȂĐ鏈                        *
*    DFRPM_RepeatNow       - Đ̋ȂJԂčĐ鏈              *
*    DFRPM_RepeatAll       - SĂ̋ȂJԂčĐ鏈                  *
*    DFRPM_RepeatDir       - w肵tH_̋ȂJԂčĐ鏈    *
*    DFRPM_SetVolume       - {[ݒ肷鏈                          *
*    DFRPM_UpVolume        - {[グ(+1)                        *
*    DFRPM_DownVolume      - {[(-1)                        *
*    DFRPM_SetEQ           - CRCU[ݒ肷鏈                        *
*                                                                              *
*    F__delay_ms() gpĂ̂ "skDFRVoiceM.h"                   *
*         "#define _XTAL_FREQ 16000000""#define FCY 60000000"LqĂ*
*         16MHzȊOCPUNbNɂl͏܂傤B                   *
*                                                                              *
*         ̊֐ẂAR}h"ԓvsv"őSđMĂ܂B         *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2019-03-17  ޒH[     Create                                 *
* ============================================================================ *
*  MPLAB X(v4.10)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.40                                        *
*******************************************************************************/
#include <xc.h>
#include "skDFRPlayerM.h"
#include "skUARTlib.h"


unsigned char DFRPM_RcvBuf[10] ;
unsigned char DFRPM_RcvP = 0 ;
unsigned int  SD_Card_Online = 0 ;      // SDJ[h 0:ItC 1:IC
unsigned int  SD_Card_State ;           // W[̏

/*******************************************************************************
*  DFRPM_Send(command, para)                                                   *
*  W[ɃR}h𑗐M鏈                                          *
*    command  : MR}hw                                         *
*    para     : R}h̃p[^w                                     *
*******************************************************************************/
void DFRPM_Send(char command,unsigned int para)
{
     union {
          int  ino ;
          char cno[2] ;
     } f ;
     char buf[10] = { 0x7E,0xFF,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0xEF } ;
     int i , sm ;

     buf[3] = command ;  // R}h̃Zbg
     f.ino  = para ;
     buf[5] = f.cno[1] ; // Para_MSB̃Zbg
     buf[6] = f.cno[0] ; // Para_LSB̃Zbg
     // `FbNTvZ
     sm = 0 ;
     for (i=1 ; i<7 ; i++) {
          sm = sm + buf[i] ;
     }
     f.ino = 0xFFFF - sm + 1 ;
     buf[7] = f.cno[1] ; // Check_MSB̃Zbg
     buf[8] = f.cno[0] ; // Check_LSB̃Zbg
     // R}h𑗐M
     UART_Send(buf,10) ;
     if (buf[4] == 0x00) __delay_ms(10) ;
}
/*******************************************************************************
*  DFRPM_Receive()                                                             *
*  W[R}hM鏈                                        *
*******************************************************************************/
void DFRPM_Receive()
{
     int  ans ;
 
     while(1) {
          ans = UART_Available() ;
          if (ans != 0) {
               DFRPM_RcvBuf[DFRPM_RcvP] = UART_Read() ;
               DFRPM_RcvP++ ;
               if (DFRPM_RcvP >= 10){
                    switch(DFRPM_RcvBuf[3]) {
                      case 0x42:
                         SD_Card_State =  (unsigned int)DFRPM_RcvBuf[6] ;
                         SD_Card_State = ((unsigned int)DFRPM_RcvBuf[5]<<8) | SD_Card_State ;
                         break ;
                      case 0x3F:
                         if (DFRPM_RcvBuf[6]==0x02 || DFRPM_RcvBuf[6]==0x03) SD_Card_Online = 1 ;
                      default : 
                         // nh[Ăяo
                         RECEIVEHANDLER(DFRPM_RcvBuf[3],DFRPM_RcvBuf[5],DFRPM_RcvBuf[6]) ;
                         break ;
                    }
                    DFRPM_RcvP = 0 ;
                    break ;   // while𔲂
               }
          } else break ;      // while𔲂
     }
}
/*******************************************************************************
*  DFRPM_Initiate(VolumeSU)                                                    *
*  W[̏lݒs                                            *
*    VolumeSU  : {[̒l(0-30)                                          *
*******************************************************************************/
void DFRPM_Initiate(unsigned char VolumeSU)
{
     // W[Zbg
     DFRPM_Reset() ;
     while(!SD_Card_Online) {
          DFRPM_Receive() ;
     }
     __delay_ms(1000) ;
     // CRCU[̐ݒ
     DFRPM_SetEQ(DFRPM_EQ_NORMAL) ;
     // {[̐ݒ
     DFRPM_SetVolume(VolumeSU) ;
}
/*******************************************************************************
*  DFRPM_Reset()                                                               *
*  W[̃Zbgs                                              *
*******************************************************************************/
void DFRPM_Reset()
{
     SD_Card_Online = 0 ;
     DFRPM_Send(0x0C,0) ;  // [0x0C]R}h̑M
}
/*******************************************************************************
*  DFRPM_Sleep()                                                               *
*  W[X[v鏈()                                      *
*******************************************************************************/
void DFRPM_Sleep()
{
     DFRPM_Send(0x0A,0x00) ;  // [0x0A]R}h̑M
}
/*******************************************************************************
*  ans = DFRPM_Status()                                                        *
*  W[݂̌̏Ԃ𓾂鏈                                            *
*    ans  : 00=~  01=Đ  02=ꎞ~  03=X[v  04=SDJ[hłȂ  *
*******************************************************************************/
char DFRPM_Status()
{
     int ans ;

     DFRPM_Send(0x42,0) ;  // [0x42]R}h̑M
     // W[̕ԓ҂
     SD_Card_State = 0 ;
     while(!SD_Card_State) {
          DFRPM_Receive() ;
     }
     ans = SD_Card_State&0x00FF ;
     if ((SD_Card_State&0xFF00) == 0x1000) ans = 0x03 ;     // X[v
     if ((SD_Card_State&0xFF00) != 0x0200) ans = 0x04 ;     // SDJ[hłȂ

     return ans ;        // ԂԂ
}
/*******************************************************************************
*  DFRPM_PlayNext()                                                            *
*  ̋Ȃ̍Đs                                                      *
*******************************************************************************/
void DFRPM_PlayNext()
{
     DFRPM_Send(0x01,0) ;  // [0x01]R}h̑M
}
/*******************************************************************************
*  DFRPM_Pause()                                                               *
*  Ȃ̍Đꎞ~鏈                                                *
*******************************************************************************/
void DFRPM_Pause()
{
     DFRPM_Send(0x0E,0) ;  // [0x0E]R}h̑M
}
/*******************************************************************************
*  DFRPM_Stop()                                                                *
*  Ȃ̍Đ~߂鏈                                                        *
*******************************************************************************/
void DFRPM_Stop()
{
     DFRPM_Send(0x16,0) ;  // [0x16]R}h̑M
}
/*******************************************************************************
*  DFRPM_Play()                                                                *
*  Ȃ̍ĐJn鏈                                                      *
*******************************************************************************/
void DFRPM_Play()
{
     DFRPM_Send(0x0D,0) ;  // [0x0D]R}h̑M
}
/*******************************************************************************
*  DFRPM_SpecifyPlay(trackNumber)                                              *
*  [gfBNg̋Ȃw肵čĐ鏈                                *
*    trackNumber  : ĐgbN̔ԍ(1-65535)                            *
*******************************************************************************/
void DFRPM_SpecifyPlay(unsigned int trackNumber)
{
     DFRPM_Send(0x03,trackNumber) ;  // [0x03]R}h̑M
}
/*******************************************************************************
*  DFRPM_SpecifyDir(dirNumber,fileNumber)                                      *
*  tH_̋(255)w肵čĐ鏈                                 *
*  ̊֐̓tH_255Ȃ܂łĐ\łB                             *
*    dirNumber   : ĐtH_̔ԍ(1-99)                                *
*    fileNumber  : Đt@C̔ԍ(1-255)                               *
*******************************************************************************/
void DFRPM_SpecifyDir(unsigned char dirNumber,unsigned char fileNumber)
{
     union {
          int  ino ;
          char cno[2] ;
     } f ;
     if ( (dirNumber!=0) && (fileNumber!=0) ) {
          f.cno[1] = dirNumber ;
          f.cno[0] = fileNumber ;
          DFRPM_Send(0x0F,f.ino) ; // [0x0F]R}h̑M
     }
}
/*******************************************************************************
*  DFRPM_SpecifyLargeDir(dirNumber,fileNumber)                                 *
*  tH_̋(3000)w肵čĐ鏈                                *
*  ̊֐̓tH_3000Ȃ܂łĐ\łB                            *
*    dirNumber   : ĐtH_̔ԍ(1-99)                                *
*    fileNumber  : Đt@C̔ԍ(1-3000)                              *
*******************************************************************************/
void DFRPM_SpecifyLargeDir(unsigned char dirNumber,unsigned int fileNumber)
{
     unsigned int para ;
     
     if ( (dirNumber!=0) && (fileNumber!=0) ) {
          para = (((unsigned int)dirNumber) << 12) | fileNumber ;
          DFRPM_Send(0x14,para) ; // [0x14]R}h̑M
     }
}
/*******************************************************************************
*  DFRPM_randomPlay()                                                          *
*  _ŋȂĐ鏈                                                  *
*******************************************************************************/
void DFRPM_randomPlay()
{
     DFRPM_Send(0x18,0) ;       // [0x18]R}h̑M
}
/*******************************************************************************
*  DFRPM_RepeatNow()                                                           *
*  Đ̋ȂJԂčĐ鏈                                        *
*******************************************************************************/
void DFRPM_RepeatNow()
{
     DFRPM_Send(0x19,0) ;       // [0x19]R}h̑M
}
/*******************************************************************************
*  DFRPM_RepeatAll(instruction)                                                *
*  SĂ̋ȂJԂčĐ鏈                                            *
*  tH_Đ܂B                                                  *
*    instruction  : 1=ĐJn  0=Đ~                                     *
*******************************************************************************/
void DFRPM_RepeatAll(unsigned char instruction)
{
     if (instruction <= 1) {
          DFRPM_Send(0x11,(unsigned int)instruction) ; // [0x11]R}h̑M
     }
}
/*******************************************************************************
*  DFRPM_RepeatDir(dirNumber)                                                  *
*  w肵tH_̋ȂJԂčĐ鏈                              *
*  ̊֐g255𒴂t@CĐł܂B                         *
*    dirNumber    : ĐtH_̔ԍ(1-99)                               *
*******************************************************************************/
void DFRPM_RepeatDir(unsigned int dirNumber)
{
     if ( (dirNumber<=99) && (dirNumber!=0) ) {
          DFRPM_Send(0x17,dirNumber) ;  // [0x17]R}h̑M
     }
}
/*******************************************************************************
*  DFRPM_SetVolume(VolumeSU)                                                   *
*  {[ݒ肷鏈                                                    *
*    VolumeSU  : {[̒l(0-30)                                          *
*******************************************************************************/
void DFRPM_SetVolume(unsigned char VolumeSU)
{
     if (VolumeSU <= DFRPM_VOL_MAX) {
          DFRPM_Send(0x06,(unsigned int)VolumeSU) ;    // [0x06]R}h̑M
     }
}
/*******************************************************************************
*  DFRPM_UpVolume()                                                            *
*  {[グ(+1)                                                  *
*******************************************************************************/
void DFRPM_UpVolume()
{
     DFRPM_Send(0x04,0) ;       // [0x04]R}h̑M
}
/*******************************************************************************
*  DFRPM_DownVolume()                                                          *
*  {[(-1)                                                  *
*******************************************************************************/
void DFRPM_DownVolume()
{
     DFRPM_Send(0x05,0) ;       // [0x05]R}h̑M
}
/*******************************************************************************
*  DFRPM_SetEQ(style)                                                          *
*  CRCU[ݒ肷鏈                                                  *
*    style  : CRCU[̃X^Cl                                         *
*             00= 01=|bv 02=bN 03=WY 04=NVbN 05=x[X    *
*******************************************************************************/
void DFRPM_SetEQ(unsigned char style)
{
     if (style <= 0x05) {
          DFRPM_Send(0x07,(unsigned int)style) ;  // [0x07]R}h̑M
     }
}

