/*******************************************************************************
*  skDFRVoiceM.h - DFROBOTMP3 DFPlayer miniW[p֐Cu      *
*                                                               wb_t@C *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2019-03-17  ޒH[     Create                                 *
*******************************************************************************/
#ifndef _SKDFRPM_H_
#define _SKDFRPM_H_

// __delay_ms__delay_usׂ̈ɕKv
#if defined(__PIC24E__) || defined(__PIC24F__)
 #ifndef FCY
  // Unless already defined assume 60MHz(60MIPS) system frequency
  #define FCY 60000000UL      // Fosc/2(60MIPS)
  #include <libpic30.h>
 #endif
#else
 // PIC12F PIC16F PIC18F p
 #ifndef _XTAL_FREQ
  // Unless already defined assume 16MHz system frequency
  #define _XTAL_FREQ 16000000 // gpPICɂ蓮glݒ肷
 #endif
#endif

/******************************************************************************/
/*  萔̒`                                                                */
/******************************************************************************/
#define RECEIVEHANDLER        ReceiveHandler // R}h̎Mnh[
void RECEIVEHANDLER(char command,char paraH,char paraL) ;

#define DFRPM_EQ_NORMAL       0x00 // 
#define DFRPM_EQ_POP          0x01 // |bv
#define DFRPM_EQ_ROCK         0x02 // bN
#define DFRPM_EQ_JAZZ         0x03 // WY
#define DFRPM_EQ_CLASSIC      0x04 // NVbN
#define DFRPM_EQ_BASS         0x05 // x[X

#define DFRPM_VOL_MAX         0x1E // {[̍ől(30)

/******************************************************************************/
/*  ϐ̒`                                                                */
/******************************************************************************/

/******************************************************************************/
/*  ֐̃vg^Cv錾                                                    */
/******************************************************************************/
void DFRPM_Send(char command,unsigned int para) ;
void DFRPM_Receive() ;
void DFRPM_Initiate(unsigned char VolumeSU) ;
void DFRPM_Reset() ;
void DFRPM_Sleep() ;
char DFRPM_Status() ;
void DFRPM_Pause() ;
void DFRPM_PlayNext() ;
void DFRPM_Stop() ;
void DFRPM_Play() ;
void DFRPM_SpecifyPlay(unsigned int trackNumber) ;
void DFRPM_SpecifyDir(unsigned char dirNumber,unsigned char fileNumber) ;
void DFRPM_SpecifyLargeDir(unsigned char dirNumber,unsigned int fileNumber) ;
void DFRPM_randomPlay() ;
void DFRPM_RepeatNow() ;
void DFRPM_RepeatAll(unsigned char instruction) ;
void DFRPM_RepeatDir(unsigned int dirNumber) ;
void DFRPM_SetVolume(unsigned char VolumeSU) ;
void DFRPM_UpVolume() ;
void DFRPM_DownVolume() ;
void DFRPM_SetEQ(unsigned char style) ;

#endif
